/*
 * generated by Xtext
 */
package org.eclipse.papyrus.parameter.editor.xtext.parseTreeConstruction;

import org.eclipse.emf.ecore.*;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parsetree.reconstr.IEObjectConsumer;
import org.eclipse.xtext.parsetree.reconstr.impl.AbstractParseTreeConstructor;

import org.eclipse.papyrus.parameter.editor.xtext.services.UmlParameterGrammarAccess;

import com.google.inject.Inject;

@SuppressWarnings("all")
public class UmlParameterParsetreeConstructor extends AbstractParseTreeConstructor {

	@Inject
	private UmlParameterGrammarAccess grammarAccess;

	@Override
	protected AbstractToken getRootToken(IEObjectConsumer inst) {
		return new ThisRootNode(inst);
	}

	protected class ThisRootNode extends RootToken {

		public ThisRootNode(IEObjectConsumer inst) {
			super(inst);
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_Group(this, this, 0, inst);
			case 1:
				return new ModifiersRule_Group(this, this, 1, inst);
			case 2:
				return new ModifierSpecification_ValueAssignment(this, this, 2, inst);
			case 3:
				return new EffectRule_Group(this, this, 3, inst);
			case 4:
				return new QualifiedName_Group(this, this, 4, inst);
			case 5:
				return new TypeRule_Group(this, this, 5, inst);
			case 6:
				return new MultiplicityRule_Group(this, this, 6, inst);
			case 7:
				return new BoundSpecification_ValueAssignment(this, this, 7, inst);
			default:
				return null;
			}
		}
	}


	/************
	 * begin Rule ParameterRule ****************
	 * 
	 * ParameterRule:
	 * visibility=VisibilityKind direction=Direction name=ID ":" (type=TypeRule | "<Undefined>")
	 * multiplicity=MultiplicityRule? modifiers=ModifiersRule? effect=EffectRule;
	 * 
	 **/

	// visibility=VisibilityKind direction=Direction name=ID ":" (type=TypeRule | "<Undefined>") multiplicity=MultiplicityRule?
	// modifiers=ModifiersRule? effect=EffectRule
	protected class ParameterRule_Group extends GroupToken {

		public ParameterRule_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_EffectAssignment_7(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getParameterRuleRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// visibility=VisibilityKind
	protected class ParameterRule_VisibilityAssignment_0 extends AssignmentToken {

		public ParameterRule_VisibilityAssignment_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getVisibilityAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("visibility", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("visibility");
			if(enumLitSerializer.isValid(obj.getEObject(), grammarAccess.getParameterRuleAccess().getVisibilityVisibilityKindEnumRuleCall_0_0(), value, null)) {
				type = AssignmentType.ENUM_RULE_CALL;
				element = grammarAccess.getParameterRuleAccess().getVisibilityVisibilityKindEnumRuleCall_0_0();
				return obj;
			}
			return null;
		}

	}

	// direction=Direction
	protected class ParameterRule_DirectionAssignment_1 extends AssignmentToken {

		public ParameterRule_DirectionAssignment_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getDirectionAssignment_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_VisibilityAssignment_0(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("direction", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("direction");
			if(enumLitSerializer.isValid(obj.getEObject(), grammarAccess.getParameterRuleAccess().getDirectionDirectionEnumRuleCall_1_0(), value, null)) {
				type = AssignmentType.ENUM_RULE_CALL;
				element = grammarAccess.getParameterRuleAccess().getDirectionDirectionEnumRuleCall_1_0();
				return obj;
			}
			return null;
		}

	}

	// name=ID
	protected class ParameterRule_NameAssignment_2 extends AssignmentToken {

		public ParameterRule_NameAssignment_2(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getNameAssignment_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_DirectionAssignment_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("name", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("name");
			if(valueSerializer.isValid(obj.getEObject(), grammarAccess.getParameterRuleAccess().getNameIDTerminalRuleCall_2_0(), value, null)) {
				type = AssignmentType.TERMINAL_RULE_CALL;
				element = grammarAccess.getParameterRuleAccess().getNameIDTerminalRuleCall_2_0();
				return obj;
			}
			return null;
		}

	}

	// ":"
	protected class ParameterRule_ColonKeyword_3 extends KeywordToken {

		public ParameterRule_ColonKeyword_3(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getColonKeyword_3();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_NameAssignment_2(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// type=TypeRule | "<Undefined>"
	protected class ParameterRule_Alternatives_4 extends AlternativesToken {

		public ParameterRule_Alternatives_4(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Alternatives getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getAlternatives_4();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_TypeAssignment_4_0(lastRuleCallOrigin, this, 0, inst);
			case 1:
				return new ParameterRule_UndefinedKeyword_4_1(lastRuleCallOrigin, this, 1, inst);
			default:
				return null;
			}
		}

	}

	// type=TypeRule
	protected class ParameterRule_TypeAssignment_4_0 extends AssignmentToken {

		public ParameterRule_TypeAssignment_4_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getTypeAssignment_4_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new TypeRule_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("type", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("type");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getTypeRuleRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getParameterRuleAccess().getTypeTypeRuleParserRuleCall_4_0_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ParameterRule_ColonKeyword_3(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}

	// "<Undefined>"
	protected class ParameterRule_UndefinedKeyword_4_1 extends KeywordToken {

		public ParameterRule_UndefinedKeyword_4_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getUndefinedKeyword_4_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ParameterRule_ColonKeyword_3(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}


	// multiplicity=MultiplicityRule?
	protected class ParameterRule_MultiplicityAssignment_5 extends AssignmentToken {

		public ParameterRule_MultiplicityAssignment_5(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getMultiplicityAssignment_5();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new MultiplicityRule_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("multiplicity", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("multiplicity");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getMultiplicityRuleRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getParameterRuleAccess().getMultiplicityMultiplicityRuleParserRuleCall_5_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ParameterRule_Alternatives_4(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}

	// modifiers=ModifiersRule?
	protected class ParameterRule_ModifiersAssignment_6 extends AssignmentToken {

		public ParameterRule_ModifiersAssignment_6(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getModifiersAssignment_6();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifiersRule_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("modifiers", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("modifiers");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getModifiersRuleRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getParameterRuleAccess().getModifiersModifiersRuleParserRuleCall_6_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ParameterRule_MultiplicityAssignment_5(lastRuleCallOrigin, next, actIndex, consumed);
			case 1:
				return new ParameterRule_Alternatives_4(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}

	// effect=EffectRule
	protected class ParameterRule_EffectAssignment_7 extends AssignmentToken {

		public ParameterRule_EffectAssignment_7(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getParameterRuleAccess().getEffectAssignment_7();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new EffectRule_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("effect", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("effect");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getEffectRuleRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getParameterRuleAccess().getEffectEffectRuleParserRuleCall_7_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ParameterRule_ModifiersAssignment_6(lastRuleCallOrigin, next, actIndex, consumed);
			case 1:
				return new ParameterRule_MultiplicityAssignment_5(lastRuleCallOrigin, next, actIndex, consumed);
			case 2:
				return new ParameterRule_Alternatives_4(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}


	/************ end Rule ParameterRule ****************/


	/************
	 * begin Rule ModifiersRule ****************
	 * 
	 * ModifiersRule:
	 * "{" values+=ModifierSpecification ("," values+=ModifierSpecification)* "}";
	 * 
	 **/

	// "{" values+=ModifierSpecification ("," values+=ModifierSpecification)* "}"
	protected class ModifiersRule_Group extends GroupToken {

		public ModifiersRule_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifiersRule_RightCurlyBracketKeyword_3(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getModifiersRuleRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// "{"
	protected class ModifiersRule_LeftCurlyBracketKeyword_0 extends KeywordToken {

		public ModifiersRule_LeftCurlyBracketKeyword_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getLeftCurlyBracketKeyword_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

	}

	// values+=ModifierSpecification
	protected class ModifiersRule_ValuesAssignment_1 extends AssignmentToken {

		public ModifiersRule_ValuesAssignment_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getValuesAssignment_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifierSpecification_ValueAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("values", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("values");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getModifierSpecificationRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getModifiersRuleAccess().getValuesModifierSpecificationParserRuleCall_1_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ModifiersRule_LeftCurlyBracketKeyword_0(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}

	// ("," values+=ModifierSpecification)*
	protected class ModifiersRule_Group_2 extends GroupToken {

		public ModifiersRule_Group_2(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getGroup_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifiersRule_ValuesAssignment_2_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// ","
	protected class ModifiersRule_CommaKeyword_2_0 extends KeywordToken {

		public ModifiersRule_CommaKeyword_2_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getCommaKeyword_2_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifiersRule_Group_2(lastRuleCallOrigin, this, 0, inst);
			case 1:
				return new ModifiersRule_ValuesAssignment_1(lastRuleCallOrigin, this, 1, inst);
			default:
				return null;
			}
		}

	}

	// values+=ModifierSpecification
	protected class ModifiersRule_ValuesAssignment_2_1 extends AssignmentToken {

		public ModifiersRule_ValuesAssignment_2_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getValuesAssignment_2_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifierSpecification_ValueAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("values", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("values");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getModifierSpecificationRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getModifiersRuleAccess().getValuesModifierSpecificationParserRuleCall_2_1_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new ModifiersRule_CommaKeyword_2_0(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}


	// "}"
	protected class ModifiersRule_RightCurlyBracketKeyword_3 extends KeywordToken {

		public ModifiersRule_RightCurlyBracketKeyword_3(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getModifiersRuleAccess().getRightCurlyBracketKeyword_3();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new ModifiersRule_Group_2(lastRuleCallOrigin, this, 0, inst);
			case 1:
				return new ModifiersRule_ValuesAssignment_1(lastRuleCallOrigin, this, 1, inst);
			default:
				return null;
			}
		}

	}


	/************ end Rule ModifiersRule ****************/


	/************
	 * begin Rule ModifierSpecification ****************
	 * 
	 * ModifierSpecification:
	 * value=ModifierKind;
	 * 
	 **/

	// value=ModifierKind
	protected class ModifierSpecification_ValueAssignment extends AssignmentToken {

		public ModifierSpecification_ValueAssignment(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getModifierSpecificationAccess().getValueAssignment();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getModifierSpecificationRule().getType().getClassifier())
				return null;
			if((value = eObjectConsumer.getConsumable("value", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("value");
			if(enumLitSerializer.isValid(obj.getEObject(), grammarAccess.getModifierSpecificationAccess().getValueModifierKindEnumRuleCall_0(), value, null)) {
				type = AssignmentType.ENUM_RULE_CALL;
				element = grammarAccess.getModifierSpecificationAccess().getValueModifierKindEnumRuleCall_0();
				return obj;
			}
			return null;
		}

	}

	/************ end Rule ModifierSpecification ****************/


	/************
	 * begin Rule EffectRule ****************
	 * 
	 * EffectRule:
	 * "{" "effect: " effectKind=EffectKind "}";
	 * 
	 **/

	// "{" "effect: " effectKind=EffectKind "}"
	protected class EffectRule_Group extends GroupToken {

		public EffectRule_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getEffectRuleAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new EffectRule_RightCurlyBracketKeyword_3(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getEffectRuleRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// "{"
	protected class EffectRule_LeftCurlyBracketKeyword_0 extends KeywordToken {

		public EffectRule_LeftCurlyBracketKeyword_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getEffectRuleAccess().getLeftCurlyBracketKeyword_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

	}

	// "effect: "
	protected class EffectRule_EffectKeyword_1 extends KeywordToken {

		public EffectRule_EffectKeyword_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getEffectRuleAccess().getEffectKeyword_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new EffectRule_LeftCurlyBracketKeyword_0(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// effectKind=EffectKind
	protected class EffectRule_EffectKindAssignment_2 extends AssignmentToken {

		public EffectRule_EffectKindAssignment_2(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getEffectRuleAccess().getEffectKindAssignment_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new EffectRule_EffectKeyword_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("effectKind", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("effectKind");
			if(enumLitSerializer.isValid(obj.getEObject(), grammarAccess.getEffectRuleAccess().getEffectKindEffectKindEnumRuleCall_2_0(), value, null)) {
				type = AssignmentType.ENUM_RULE_CALL;
				element = grammarAccess.getEffectRuleAccess().getEffectKindEffectKindEnumRuleCall_2_0();
				return obj;
			}
			return null;
		}

	}

	// "}"
	protected class EffectRule_RightCurlyBracketKeyword_3 extends KeywordToken {

		public EffectRule_RightCurlyBracketKeyword_3(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getEffectRuleAccess().getRightCurlyBracketKeyword_3();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new EffectRule_EffectKindAssignment_2(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}


	/************ end Rule EffectRule ****************/


	/************
	 * begin Rule QualifiedName ****************
	 * 
	 * QualifiedName:
	 * path=[uml::Namespace] "::" remaining=QualifiedName?;
	 * 
	 **/

	// path=[uml::Namespace] "::" remaining=QualifiedName?
	protected class QualifiedName_Group extends GroupToken {

		public QualifiedName_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getQualifiedNameAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new QualifiedName_RemainingAssignment_2(lastRuleCallOrigin, this, 0, inst);
			case 1:
				return new QualifiedName_ColonColonKeyword_1(lastRuleCallOrigin, this, 1, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getQualifiedNameRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// path=[uml::Namespace]
	protected class QualifiedName_PathAssignment_0 extends AssignmentToken {

		public QualifiedName_PathAssignment_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getQualifiedNameAccess().getPathAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("path", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("path");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::CrossReferenceImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getQualifiedNameAccess().getPathNamespaceCrossReference_0_0().getType().getClassifier())) {
					type = AssignmentType.CROSS_REFERENCE;
					element = grammarAccess.getQualifiedNameAccess().getPathNamespaceCrossReference_0_0();
					return obj;
				}
			}
			return null;
		}

	}

	// "::"
	protected class QualifiedName_ColonColonKeyword_1 extends KeywordToken {

		public QualifiedName_ColonColonKeyword_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getQualifiedNameAccess().getColonColonKeyword_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new QualifiedName_PathAssignment_0(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// remaining=QualifiedName?
	protected class QualifiedName_RemainingAssignment_2 extends AssignmentToken {

		public QualifiedName_RemainingAssignment_2(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getQualifiedNameAccess().getRemainingAssignment_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new QualifiedName_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("remaining", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("remaining");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getQualifiedNameRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getQualifiedNameAccess().getRemainingQualifiedNameParserRuleCall_2_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new QualifiedName_ColonColonKeyword_1(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}


	/************ end Rule QualifiedName ****************/


	/************
	 * begin Rule TypeRule ****************
	 * 
	 * TypeRule:
	 * path=QualifiedName? type=[uml::Type];
	 * 
	 **/

	// path=QualifiedName? type=[uml::Type]
	protected class TypeRule_Group extends GroupToken {

		public TypeRule_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getTypeRuleAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new TypeRule_TypeAssignment_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getTypeRuleRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// path=QualifiedName?
	protected class TypeRule_PathAssignment_0 extends AssignmentToken {

		public TypeRule_PathAssignment_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getTypeRuleAccess().getPathAssignment_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new QualifiedName_Group(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("path", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("path");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getQualifiedNameRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getTypeRuleAccess().getPathQualifiedNameParserRuleCall_0_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(next, actIndex, index, consumed);
			}
		}
	}

	// type=[uml::Type]
	protected class TypeRule_TypeAssignment_1 extends AssignmentToken {

		public TypeRule_TypeAssignment_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getTypeRuleAccess().getTypeAssignment_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new TypeRule_PathAssignment_0(lastRuleCallOrigin, this, 0, inst);
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index - 1, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("type", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("type");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::CrossReferenceImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getTypeRuleAccess().getTypeTypeCrossReference_1_0().getType().getClassifier())) {
					type = AssignmentType.CROSS_REFERENCE;
					element = grammarAccess.getTypeRuleAccess().getTypeTypeCrossReference_1_0();
					return obj;
				}
			}
			return null;
		}

	}


	/************ end Rule TypeRule ****************/


	/************
	 * begin Rule MultiplicityRule ****************
	 * 
	 * MultiplicityRule:
	 * "[" bounds+=BoundSpecification (".." bounds+=BoundSpecification)? "]";
	 * 
	 **/

	// "[" bounds+=BoundSpecification (".." bounds+=BoundSpecification)? "]"
	protected class MultiplicityRule_Group extends GroupToken {

		public MultiplicityRule_Group(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getGroup();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new MultiplicityRule_RightSquareBracketKeyword_3(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getMultiplicityRuleRule().getType().getClassifier())
				return null;
			return eObjectConsumer;
		}

	}

	// "["
	protected class MultiplicityRule_LeftSquareBracketKeyword_0 extends KeywordToken {

		public MultiplicityRule_LeftSquareBracketKeyword_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getLeftSquareBracketKeyword_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

	}

	// bounds+=BoundSpecification
	protected class MultiplicityRule_BoundsAssignment_1 extends AssignmentToken {

		public MultiplicityRule_BoundsAssignment_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new BoundSpecification_ValueAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("bounds", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("bounds");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getBoundSpecificationRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getMultiplicityRuleAccess().getBoundsBoundSpecificationParserRuleCall_1_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new MultiplicityRule_LeftSquareBracketKeyword_0(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}

	// (".." bounds+=BoundSpecification)?
	protected class MultiplicityRule_Group_2 extends GroupToken {

		public MultiplicityRule_Group_2(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Group getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getGroup_2();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new MultiplicityRule_BoundsAssignment_2_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// ".."
	protected class MultiplicityRule_FullStopFullStopKeyword_2_0 extends KeywordToken {

		public MultiplicityRule_FullStopFullStopKeyword_2_0(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getFullStopFullStopKeyword_2_0();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new MultiplicityRule_BoundsAssignment_1(lastRuleCallOrigin, this, 0, inst);
			default:
				return null;
			}
		}

	}

	// bounds+=BoundSpecification
	protected class MultiplicityRule_BoundsAssignment_2_1 extends AssignmentToken {

		public MultiplicityRule_BoundsAssignment_2_1(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getBoundsAssignment_2_1();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new BoundSpecification_ValueAssignment(this, this, 0, inst);
			default:
				return null;
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if((value = eObjectConsumer.getConsumable("bounds", false)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("bounds");
			if(value instanceof EObject) { // org::eclipse::xtext::impl::RuleCallImpl
				IEObjectConsumer param = createEObjectConsumer((EObject)value);
				if(param.isInstanceOf(grammarAccess.getBoundSpecificationRule().getType().getClassifier())) {
					type = AssignmentType.PARSER_RULE_CALL;
					element = grammarAccess.getMultiplicityRuleAccess().getBoundsBoundSpecificationParserRuleCall_2_1_0();
					consumed = obj;
					return param;
				}
			}
			return null;
		}

		@Override
		public AbstractToken createFollowerAfterReturn(AbstractToken next, int actIndex, int index, IEObjectConsumer inst) {
			if(value == inst.getEObject() && !inst.isConsumed())
				return null;
			switch(index) {
			case 0:
				return new MultiplicityRule_FullStopFullStopKeyword_2_0(lastRuleCallOrigin, next, actIndex, consumed);
			default:
				return null;
			}
		}
	}


	// "]"
	protected class MultiplicityRule_RightSquareBracketKeyword_3 extends KeywordToken {

		public MultiplicityRule_RightSquareBracketKeyword_3(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Keyword getGrammarElement() {
			return grammarAccess.getMultiplicityRuleAccess().getRightSquareBracketKeyword_3();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			case 0:
				return new MultiplicityRule_Group_2(lastRuleCallOrigin, this, 0, inst);
			case 1:
				return new MultiplicityRule_BoundsAssignment_1(lastRuleCallOrigin, this, 1, inst);
			default:
				return null;
			}
		}

	}


	/************ end Rule MultiplicityRule ****************/


	/************
	 * begin Rule BoundSpecification ****************
	 * 
	 * BoundSpecification:
	 * value=UnlimitedLiteral;
	 * 
	 **/

	// value=UnlimitedLiteral
	protected class BoundSpecification_ValueAssignment extends AssignmentToken {

		public BoundSpecification_ValueAssignment(AbstractToken lastRuleCallOrigin, AbstractToken next, int transitionIndex, IEObjectConsumer eObjectConsumer) {
			super(lastRuleCallOrigin, next, transitionIndex, eObjectConsumer);
		}

		@Override
		public Assignment getGrammarElement() {
			return grammarAccess.getBoundSpecificationAccess().getValueAssignment();
		}

		@Override
		public AbstractToken createFollower(int index, IEObjectConsumer inst) {
			switch(index) {
			default:
				return lastRuleCallOrigin.createFollowerAfterReturn(this, index, index, inst);
			}
		}

		@Override
		public IEObjectConsumer tryConsume() {
			if(getEObject().eClass() != grammarAccess.getBoundSpecificationRule().getType().getClassifier())
				return null;
			if((value = eObjectConsumer.getConsumable("value", true)) == null)
				return null;
			IEObjectConsumer obj = eObjectConsumer.cloneAndConsume("value");
			if(valueSerializer.isValid(obj.getEObject(), grammarAccess.getBoundSpecificationAccess().getValueUnlimitedLiteralTerminalRuleCall_0(), value, null)) {
				type = AssignmentType.TERMINAL_RULE_CALL;
				element = grammarAccess.getBoundSpecificationAccess().getValueUnlimitedLiteralTerminalRuleCall_0();
				return obj;
			}
			return null;
		}

	}

	/************ end Rule BoundSpecification ****************/

}
